#!/usr/bin/python

import dbus
import dbus.service
from dbus.mainloop.glib import DBusGMainLoop
import threading
import sys, time

_MY_DBUS_SERVICE_NAME = "org.refresh.iot"
_MY_DBUS_INTERFACE_NAME = "org.refresh.iot"
_MY_DBUS_LOC = "/"

DBusGMainLoop(set_as_default=True)

MetaDbusObject= type (dbus.service.Object)
MetaThreadObject = type (threading.Thread)


#############################################################
class MetaDBusWorker(MetaDbusObject, MetaThreadObject):
  def __init__(self, name, bases, members):
    
    MetaDbusObject.__init__ (self, name, bases, members)
    MetaThreadObject.__init__ (self, name, bases, members)

##############################################################    
class DBusWorker(dbus.service.Object, threading.Thread):
  
  __metaclass__= MetaDBusWorker
  _threads = []
  
  ######################################
  def __init__(self):
    #print "Init DBusWorker Object"
    busName = dbus.service.BusName(_MY_DBUS_SERVICE_NAME, bus=dbus.SessionBus())
    dbus.service.Object.__init__(self, busName, _MY_DBUS_LOC)

    bus = dbus.SessionBus()
    threading.Thread.__init__(self)


  #####################################
  # SIGNAL EXPOSED TO DBUS
  @dbus.service.signal(_MY_DBUS_INTERFACE_NAME)
  def setPlaylist(self, url):
    print "sending set playlist signal", url
    pass

  @dbus.service.signal(_MY_DBUS_INTERFACE_NAME)
  def setMRSS(self, url):
    print "sending set mrss signal", url
    pass

 
  #####################################    
  def setThreads( self, threads ):
    self._threads = threads;


  #####################################    
  def isAlive(self):
    print "DBusWorker alive"
    return "yes"

  def terminate(self):
    self._running = False;
