#!/bin/bash
#
# Import New Refresh Version
#
# Michal Augustyniak : michal.augustyniak@cornelius.com
# Jeff Joray : jeff.joray@cornelius.com
#
NORMAL=0
ERROR_USAGE=1
ERROR_FILE_NOT_FOUND=2

echo "Importing software, please wait..."

if [ $# -lt 1 ];
then
  echo "Error:please profide a file path to import"
  exit $ERROR
fi

filename="$1"
if [ ! -f "$filename" ]; then
  echo "Error: file not found $filename"
  exit $ERROR_FILE_NOT_FOUND
fi

VERSION=${filename#*cornelius-}
VERSION=${VERSION%.tar.gz}

echo "Importing $VERSION from $filename..."

# MAKING ALL REQUIRED PATHS
mkdir -p /opt/Refresh/
mkdir -p /opt/Refresh/Manuals
mkdir -p /opt/Refresh/Versions
mkdir -p /opt/Refresh/Wallpapers
mkdir -p /opt/Refresh/Database
mkdir -p /opt/Refresh/Pictures
mkdir -p /opt/Refresh/Pictures/Shared
mkdir -p /opt/Refresh/Pictures/MainUI
mkdir -p /opt/Refresh/Pictures/ServiceUI
mkdir -p /opt/Refresh/Videos
mkdir -p /opt/Refresh/Videos/Shared
mkdir -p /opt/Refresh/Videos/MainUI
mkdir -p /opt/Refresh/Videos/ServiceUI
rm -rf /opt/Refresh/Versions/$VERSION

# COPY EVERYTHING INTO NEW LOCATION
tar -xf "$filename" -C /opt/Refresh/Versions/ || exit 1


echo "Done"
exit $NORMAL
