#!/bin/bash

SERVICE_NAME='VideoPlayer'
SERVICE_LOCATION="../$SERVICE_NAME"
SERVICE_BIN='VideoPlayer.py'
SERVICE_LOG_FILE="/var/log/Refresh/$SERVICE_NAME.log"


function printUsage {
  echo "USAGE: $0 start/stop/kill/status" 
  exit 1
}


function executeStart {  

  cd $SERVICE_LOCATION
  # GST_DEBUG=3,GST_MEMORY:5,python:5,gnl*:5 ./$SERVICE_BIN >> $SERVICE_LOG_FILE 2>&1 &  
  # GST_DEBUG=3,python:5,gnl*:5 
  nice --18 ./$SERVICE_BIN >> $SERVICE_LOG_FILE 2>&1 &  
  exit 0  
}


function executeKill {

  pkill -x $SERVICE_BIN
  exit 0
}


function executeStop {

  dbus-send --type=method_call --session --dest=org.refresh.videoPlayer / org.refresh.videoPlayer.quitApp
  exit 0
}


function executeStatus {

  numProcesses=`pgrep -x $SERVICE_BIN | wc -l`
  
  if [[ numProcesses -gt 0 ]]; then
    #echo "we found at least one process"
    exit 0
  else
    #echo "no processes found"
    exit 1
  fi
}


# check for the correct number of parameters
if [ "$#" -lt 1 ]; then  
  printUsage
fi

case $1 in
"start")
  executeStart
  ;;
"stop")
  executeStop
  ;;
"kill")
  executeKill
  ;;
"status")
  executeStatus
  ;;
esac

