#!/bin/bash
#
# Siva sankari Govindaraju : Wait procees to hang on service UI before opening video UI and Main UI
#
SERVICE_NAME='ServiceUI'
SERVICE_BIN='ServiceUI'

function printUsage {
  echo "USAGE: $0 start/stop/kill/status" 
  exit 1
}


function executeStart {  
filename="/tmp/service.lock"
if [ -f "$filename" ]
then
echo "Waiter started"
fi

while [ -f "$filename" ]
do
sleep 5
done
echo "wait cancelled"
  exit 0  
}


function executeKill {

  pkill -x $SERVICE_BIN
  exit 0
}

function executeStatus {

  numProcesses=`pgrep -x $SERVICE_NAME | wc -l`
  
  if [[ numProcesses -gt 0 ]]; then
    #echo "we found at least on process"
    exit 0
  else
    #echo "no processes found"
    exit 1
  fi
}


# check for the correct number of parameters
if [ "$#" -lt 1 ]; then  
  printUsage
fi

case $1 in
"start")
  executeStart
  ;;
"kill")
  executeKill
  ;;
"status")
  executeStatus
  ;;
esac
