#!/bin/bash

SERVICE_NAME='WatchDog'
SERVICE_LOCATION="../$SERVICE_NAME"
SERVICE_BIN='WatchDog.sh'
SERVICE_LOG_FILE="/var/log/Refresh/$SERVICE_NAME.log"


function printUsage {
  echo "USAGE: $0 start/stop/kill/status" 
  exit 1
}


function executeStart {  

  cd $SERVICE_LOCATION
  ./$SERVICE_BIN >> $SERVICE_LOG_FILE 2>&1 &  
  exit 0  
}


function executeKill {

  pkill -x $SERVICE_BIN
  exit 0
}


function executeStop {

  executeKill
}


function executeStatus {

  numProcesses=`pgrep -x $SERVICE_BIN | wc -l`
  
  if [[ numProcesses -gt 0 ]]; then
    #echo "we found at least on process"
    exit 0
  else
    #echo "no processes found"
    exit 1
  fi
}


# check for the correct number of parameters
if [ "$#" -lt 1 ]; then  
  printUsage
fi

case $1 in
"start")
  executeStart
  ;;
"stop")
  executeStop
  ;;
"kill")
  executeKill
  ;;
"status")
  executeStatus
  ;;
esac
