#!/bin/bash
#
# additional refresh setup
#
# Michal Augustyniak : michal.augustyniak@cornelius.com
# Jeff Joray: jeff.joray@cornelius.com
#

NORMAL=0
ERROR=1
exitWithError() {
  echo "Error: $1"
  exit $ERROR
}

echo -e "Setting Refresh Autostart"

# In case both desktops are installed for some reason (development?) set up both...

if [ -d ~/.kde ]; then
	# AUTOSTART FOR KDE
	mkdir -p ~/.kde/Autostart || exitWithError "mkdir -p ~/.kde/Autostart failed"
	cp refresh.autostart ~/.kde/Autostart/refresh || exitWithError "cp refresh.autostart ~/.kde/Autostart/refresh failed"
	chmod +x ~/.kde/Autostart/refresh || exitWithError "chmod +x ~/.kde/Autostart/refresh failed"
	ERROR=0
fi

if [ -d ~/.config/openbox ]; then
	# AUTOSTART FOR OPENBOX
	cp refresh.autostart ~/.config/openbox/autostart || exitWithError "cp refresh.autostart ~/.config/openbox/autostart failed"
	chmod +x ~/.config/openbox/autostart || exitWithError "chmod +x ~/.config/openbox/autostart failed"
	ERROR=0
fi

if [ $ERROR -ne 0 ]; then
	exitWithError "No expected desktop environment found!"
fi

exit $NORMAL