#!/bin/bash
#
# Log rotation
#
# Michal Augustyniak : michal.augustyniak@cornelius.com
#
NORMAL=0
ERROR=1
exitWithError() {
  echo "Error: $1"
  exit $ERROR
}

echo -e "Setting Refresh Log Rotation"
cp -f logrotate /etc/logrotate.d/refresh || exitWithError "cp -f logrotate /etc/logrotate.d/refresh failed"
chown root:root /etc/logrotate.d/refresh || exitWithError "chown root:root /etc/logrotate.d/refresh failed"
chmod 644 /etc/logrotate.d/refresh || exitWithError "chmod 644 /etc/logrotate.d/refresh failed"

echo -e "Restarting log rotation"
logrotate -v -f /etc/logrotate.d/refresh #&> /dev/null  || exitWithError "logrotate -v -f /etc/logrotate.d/refresh &> /dev/null failed"

echo -e "Set logrotate to run hourly"
cp -v /etc/cron.daily/logrotate /etc/cron.hourly


exit $NORMAL
