#!/usr/bin/python
#
# Connects to refresh database, checks and returns setup flag
#
# "setup" == None 	means show setup app ( no "setup record found" )
# "setup" == False 	means show setup app
# "setup" == True 	means start system normally

import sqlite3
from pysqlcipher import dbapi2 as sqlcipher
import pragma

class Setup():
  
  # keeps db connection
  con = None
  
  def __init__(self, fileName):
    self.fileName = fileName

  def __del__(self):
    self.close()
  
  def connect(self):
    try:
      self.con = sqlcipher.connect(self.fileName)
      c = self.con.cursor()
      c.execute('PRAGMA key=' + pragma.key)
      c.execute('pragma kdf_iter=64000;');
      return True   
    except:
      print "Could not connect to database: " + self.fileName
      return False     

  def close(self):
    if self.con:
      self.con.close()

  def dictionaryGet(self, name):
    queryResult = None
    if self.connect():
      try:
        queryResult = self.con.execute("SELECT value FROM dictionary WHERE name='" + name + "'").fetchone()      
        queryResult = queryResult[0]
      except sqlite3.Error as e:
        print "An error occurred:", e.args[0]
        queryResult = None
      except:
        queryResult = None
      self.close()
    return queryResult
  

if __name__ == "__main__":
  
  setup = Setup("/opt/Refresh/Database/refresh_database_enc.db")
  
  flag = setup.dictionaryGet("setupCustomized")
  print flag
