#!/bin/bash
#
# Michal Augustyniak : michal.augustyniak@cornelius.com
#

print_system_current_version()
{
  echo $ROOT_LOCATION;
  if [ ! -d "$ROOT_LOCATION" ];
  then
    echo "Error: $SYSTEM_NAME is not installed"
    echo ""
  elif [ ! -f $ROOT_LOCATION/metadata.txt ];
  then
    echo "Couldn't find metadata.txt file in "$ROOT_LOCATION/metadata.txt
    echo ""
  else
      SYSTEM_VERSION=$(awk -F "=" '/version/ {print $2}' "$ROOT_LOCATION/metadata.txt")
      echo -ne "$SYSTEM_NAME version: " 
      echo $SYSTEM_VERSION
      echo ""
  fi
}

system_get_versions()
{
  declare -i i=0;
  
  cd $SYSTEM_VERSIONS_LOCATION
  
  for f in * ; do 
    if [ "$f" != "Refresh-current" ] && [[ "${f}" =~ "-" ]]; then
    i=$i+1;
    SYSTEM_VERSIONS[$i]=$f
    fi
  done
}

print_system_versions()
{
  print_system_current_version
  
  system_get_versions
  
  currentRefreshVersion=`readlink Refresh-current`
  for i in "${!SYSTEM_VERSIONS[@]}"
  do
    ver=${SYSTEM_VERSIONS[$i]}
    if [ "$currentRefreshVersion" == "$ver" ]
    then
      echo -e "\t* $i:\t$ver";
    else
      echo -e "\t  $i:\t$ver";
    fi
    
  done
  echo ""
}

print_system_env()
{
  echo 
  echo -e "System Name:              $SYSTEM_NAME" 
  echo -e "System Root path:         $ROOT_LOCATION"
  echo -e "System Logs path:         $SYSTEM_LOGS_LOCATION"
  echo -e "Corco Tool path:          $CORCO_TOOL_LOCATION"
  echo -e "Corco Scripts path:       $CORCO_TOOL_SCRIPTS_LOCATION"
  echo -e ""
}
