#!/bin/bash
#
# Michal Augustyniak : michal.augustyniak@cornelius.com
#

watchdog_check()
{  
  cd $CORCO_TOOL_SCRIPTS_LOCATION
   
  for i in "${!WATCHDOG_SERVICES[@]}"
  do
    #echo "$i"
    name=$i
    filename="watchdog-$name.sh"
    filenamePY="watchdog-$name.py"
    
    if [ -e "$filename" ];then
      response=`./$filename`        
    elif [ -e "$filenamePY" ];then
      response=`./$filenamePY`          
    else
      echo "Couldn't find '$filename' or '$filenamePY' in $CORCO_TOOL_SCRIPTS_LOCATION"
      return;        
    fi      
    
    if [ "$response" != "yes" ]; then
      timestamp=`date +"%m-%d-%Y %H:%M:%S"`
      echo "WatchDog Check" $timestamp            
      log "Service $name" $LOG_WARNING "DEAD"
      service_kill $name      
      service_start $name
      echo "end"
    else
      # Print status once every 10 minutes...
      # Get time of day in seconds
      tod=$(date +%s)
      # If tod is within 2 seconds of 10 minutes then print log
      if [ $(( $tod % 600 )) -le 2 ] ; then
        log "Service $name running" $LOG_OK "OK"
      fi
    fi
   
  done
}