#!/bin/bash
#
#  exports Refresh flavorCombos table
#
#
#
NORMAL=0
ERROR=1

exitWithError() {
  echo "!!!!!!!!!!!!!!!!!!!!!!!!!!"
  echo "!!! Exiting with error !!!"
  echo "!!!!!!!!!!!!!!!!!!!!!!!!!!"
  echo "Info: $1"
  
  #show an exit countdown
  displayCountdown 5
  
  exit $ERROR
}

displayCountdown() {
  max=$1
  for ((i=$max;i>0;i-=1)); do
    echo -en "\rexiting in $i  "
    sleep 1
  done
  echo -e "\rdone           "
}

REFRESH_ROOT_FOLDER="/opt/Refresh/"
DATABASE_LOCATION="/Database/"
DATABASE_FILE="refresh_database_enc.db"
SCRIPTS_FOLDER="$REFRESH_ROOT_FOLDER/Versions/Refresh-current/ServiceUI/Scripts"

declare -a DATABASE_TABLE_LIST=("flavorCombos")

# check that the destination location was passes in as the first arg
[ $# -gt 0 ] || exitWithError "target location was not specified"
targetLocation="$1" || exitWithError "unable to set the target location from provided input parameters"
echo "targetLocation = $targetLocation"

# go to the starting directory
cd "$REFRESH_ROOT_FOLDER" || exitWithError "Refresh root folder doesn't exist on this machine"

# export all the needed database tables
for tableName in ${DATABASE_TABLE_LIST[@]}; do 
  echo "exporting table $tableName"
  #sqlite3 -csv ".$DATABASE_LOCATION$DATABASE_FILE" "SELECT * FROM $tableName;" > "$TEMP_FOLDER_NAME/$tableName.csv" || exitWithError "couldn't export table $tableName"

  python $SCRIPTS_FOLDER/configurationBackupHelper.pyc ".$DATABASE_LOCATION$DATABASE_FILE"   "$targetLocation/$tableName.csv" $tableName || exitWithError "couldn't export $tableName from file"

done

echo "Export completed successfully"
displayCountdown 5
exit $NORMAL

