#!/bin/bash
#
# Restores Refresh flavorCombo table from file
#
#
#
NORMAL=0
ERROR=1

exitWithError() {
  #echo "!!!!!!!!!!!!!!!!!!!!!!!!!!"
  #echo "!!! Exiting with error !!!"
  #echo "!!!!!!!!!!!!!!!!!!!!!!!!!!"
  echo "error Info: $1"
  sleep 1
  echo "ERROR CASE"
  #show an exit countdown
  displayCountdown 5 
  exit $ERROR
}

displayCountdown() {
  max=$1
  for ((i=$max;i>0;i-=1)); do
    #echo -en "\rexiting in $i"
    sleep 1
  done
  echo -e "\rdone           "
}


REFRESH_ROOT_FOLDER="/opt/Refresh"
DATABASE_LOCATION="/Database"
DATABASE_FILE="$REFRESH_ROOT_FOLDER$DATABASE_LOCATION/refresh_database_enc.db"
SCRIPTS_FOLDER="$REFRESH_ROOT_FOLDER/Versions/Refresh-current/ServiceUI/Scripts"

# check that all the refresh resources exist
echo "checking system configuration..."
cd $REFRESH_ROOT_FOLDER ] || exitWithError "unable to change to the Refresh root directory ($REFRESH_ROOT_FOLDER)"
[ -f $DATABASE_FILE ] || exitWithError "refresh database file not found. please check that refresh software is correctly installed on this machine"
# check that a configuration file is all good in the hood
echo "checking input parameters..."
[ $# -gt 0 ] || exitWithError "configuration file was not specified"
fullConfigurationFilePath="$1" || exitWithError "unable to set the configuration file from provided input parameters"
configurationFilePath=${fullConfigurationFilePath%\/*}\/
configurationFileName=${fullConfigurationFilePath##*\/}
#echo "config file path: $configurationFilePath"
#echo "config file name: $configurationFileName"
[ -d "$configurationFilePath" ] || exitWithError "provided configuration file path ($configurationFilePath) was not found"
cd $configurationFilePath || exitWithError "unable to change to directory ($configurationFilePath)"
[ -f "$configurationFileName" ] || exitWithError "provided configuration file name ($configurationFileName) was not found"
cd $REFRESH_ROOT_FOLDER || exitWithError "unable to change to directory ($REFRESH_ROOT_FOLDER) after configuration file check"
  

echo "import database table..."
for filePath in "$configurationFilePath$configurationFileName"; do
  fileName=${filePath##*\/}       # strip out the filename 
  tableName=${fileName%*.csv}     # strip out the tablename    
  echo "fileName: $fileName"  

  # delete the existing database contents and update from csv file

  python $SCRIPTS_FOLDER/configurationRestoreHelper.pyc "$DATABASE_FILE" $filePath $tableName || exitWithError "couldn't import $tableName from file"

done
  
echo "Flavor Combos load completed  successfully"
displayCountdown 5
sleep 2
echo "Success"
exit $NORMAL
