#!/bin/bash
#
# Backs up current Refresh IoT configuration
#
#
NORMAL=0
ERROR=1

exitWithError() {
  echo "!!!!!!!!!!!!!!!!!!!!!!!!!!"
  echo "!!! Exiting with error !!!"
  echo "!!!!!!!!!!!!!!!!!!!!!!!!!!"
  echo "Info: $1"
  
  #show an exit countdown
  displayCountdown 20
  
  exit $ERROR
}

displayCountdown() {
  max=$1
  for ((i=$max;i>0;i-=1)); do
    echo -en "\rexiting in $i  "
    sleep 1
  done
  echo -e "\rdone           "
}

REFRESH_FOLDER="/opt/Refresh"

# check that the destination location was passes in as the first arg
[ $# -gt 0 ] || exitWithError "target location was not specified"
targetLocation="$1" || exitWithError "unable to set the target location from provided input parameters"
echo "targetLocation = $targetLocation"

# create the tarball
echo "creating configuration package. please wait..."

pushd  $REFRESH_FOLDER/IoT
tar -zcvf  "$targetLocation" . || exitWithError "Unable to create backup file"

popd

echo "IoT Configuration backup completed successfully"
displayCountdown 5
exit $NORMAL

