#!/usr/bin/python

import sqlite3
from pysqlcipher import dbapi2 as sqlcipher
import os
import sys
import time
import pragma
#from logger import Logger
from urllib2 import urlparse
import traceback

video_path = "/opt/Refresh/Videos/CMS/"
tmp_video_path = "/opt/Refresh/Videos/CMS/tmp/"


#946684800 = 1/1/2000:00:00:00

class DatabaseConnection():

  def __init__(self, fileName):
    self.fileName = fileName   
    self.db_open = False

    # make sure the database connection is closed when object is destroyed
  def __del__(self):
    #Logger.debug("Databasue", "Deleting Database")
    self.close()
  
  def connect(self):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName
    #Logger.debug("Database", "connect to database")
    if (self.db_open == True):
       return True
    try:
      self.con = sqlcipher.connect(self.fileName)
      c = self.con.cursor()
      c.execute('PRAGMA key=' + pragma.key)
      c.execute('pragma kdf_iter=64000;');
      c.execute('pragma busy_timeout=100 ;');
      c.execute('pragma cache_size=4000;');
	  # When synchronous is FULL (2), the SQLite database engine will use the xSync method 
	  # of the VFS to ensure that all content is safely written to the disk surface prior 
	  # to continuing. This ensures that an operating system crash or power failure will 
	  # not corrupt the database. FULL synchronous is very safe, but it is also slower.
      c.execute('pragma synchronous=2;');
      self.db_open = True
      #Logger.debug("Database", 'database opened')
      return True   
    except:
      #Logger.debug("Database", sys.exc_info() )
      
      #Logger.debug("Database", "!!!!! unable to connect to db !!!!!")
      return False     

  def close(self):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName
    if self.con:
      self.con.close()
    self.db_open = False

  def query(self, queryString):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + queryString 
    if self.connect():
      try:
        return self.con.execute(queryString).fetchone()
      except:
	self.close()
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " RESULT: " + queryResult
    return None

  def queryGetColumn(self, queryString):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + queryString

    sys.stdout.flush()
    queryResult = [None]
    if self.connect():
      try:
        queryResult = self.con.execute(queryString).fetchall()
      except:
        queryResult = None
	self.close()
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " RESULT: " + queryResult
    return queryResult

  def dictionaryGet(self, name):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + name 
    sys.stdout.flush()
    for retry in range(0, 10):
      if self.connect():
        try:
          sql = "SELECT value FROM dictionary WHERE name='" + name + "'"
          queryResult = self.con.execute("SELECT value FROM dictionary WHERE name='" + name + "'").fetchone()
          if queryResult:
            return queryResult[0]
          break
        except:
          self.close()
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " RESULT: " + queryResult
    return ""

  def dictionarySet(self, name, value):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + name + " " + str(value)
    sys.stdout.flush()
    queryResult = None
    update = self.dictionaryExists(name)
    if self.connect():
      try:
	if update:
	  queryResult = self.con.execute("UPDATE dictionary SET value='" + value + "' WHERE name='" + name + "'")
	else:
	  queryResult = self.con.execute("INSERT INTO dictionary (name, value) VALUES ('" + name + "','" + value + "')")
	self.con.commit()
      except:
	self.close()
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " RESULT: " + queryResult
    return
  
  def dictionaryExists(self, name):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + name
    if self.connect() and self.con.execute("SELECT * FROM dictionary WHERE name='" + name + "'").fetchone():
      return True
    return False;
      
  def saveVideoPath(self, path):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + path 
    return self.dictionarySet("videoPath", path)
 
  def getPlaylistFileValidTimes(self, fname):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + fname 
    sys.stdout.flush()
    for retry in range(0,5):
      self.connect()
      try:
        queryString = "SELECT valid_start, valid_end FROM playlistFilesExtInfo t2 inner join playlistFiles as t1 on t2.playlistFile_id=t1.id and t1.filename = '"+ fname[fname.rfind('/') +1 :] + "'"
        queryResult = self.con.execute(queryString).fetchall()
        if queryResult:
          print 'valid times'
          print queryResult
          return queryResult
        break
      except:
        traceback.print_exc()
        self.close()
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + str(rows)
    return []


  def getPlayListFilesFromId(self, id):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + str(id)
    sys.stdout.flush()
    self.connect()
    rows = []
    try:
      rows = self.con.execute("SELECT filename FROM playlistFiles WHERE playlist_id = '" + str(id) + "' order by play_order asc").fetchall()
    except:
      self.close()

	  # print "[defDatabase] " + sys._getframe().f_code.co_name + " RESULT: " + str(queryResult)

    return [row[0] for row in rows]

  def getPlayListDefault(self):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " 
    sys.stdout.flush()

    for retry in range(0,5):
      self.connect()
      try:
        return self.con.execute("SELECT id,name FROM playlist WHERE name = 'default'").fetchone()
      except:
        self.close()
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " RESULT: " + " ".join([str(i) for i in queryResult])
    return None

  def UpdateStats(self, uri, media_source):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + uri + " " + media_source
    sys.stdout.flush()
    # check if a record exits
    queryResult = None
    self.connect()
    try:
      cur = self.con.cursor()
      queryString = "SELECT COUNT(*) from playListStatistics where uri='" + uri + "'";
      #Logger.debug("Database", queryString)
      queryResult = self.con.execute(queryString).fetchall()[0]
      count = queryResult[0]
      if count == 0:
	queryString = "INSERT INTO playlistStatistics Values(null, '" + uri +"', '" + media_source +"', " + str(int(time.time())) + "," + str(int(time.time())) + ", 1, '')"
	#Logger.debug("Database", queryString)
	cur.execute(queryString)
	self.con.commit()
    
      else:
	queryString = "SELECT  play_count from playListStatistics where uri='" + uri + "'";

	#Logger.debug("Database", queryString)
	queryResult = self.con.execute(queryString).fetchall()[0]
	count = queryResult[0]
	count += 1
	queryString = "Update playListStatistics set play_count=" + str(count) + ", last_play=" + str(int(time.time())) + " where uri='" + uri + "'"
	#Logger.debug("Database", queryString)
	cur.execute(queryString)
	self.con.commit()
    except:
	self.close()
      
    
  def getPlayListFromCurrentTime(self, time):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + time 
    sys.stdout.flush()
    for retry in range(0, 5) :
      self.connect()
      try:
        queryResult = self.con.execute("SELECT id, name FROM playlist WHERE  time('" + time + "') >= time(start_time) and time('" + time + "') < time(end_time)").fetchone()
        if queryResult:
          return queryResult
        break
      except:
        #traceback.print_exc(file=sys.stdout)
        self.close()
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " RESULT: " + str(queryResult)
    return None

  def deleteAllPlaylists(self):
      # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " 
      self.connect()
      try:
	cur = self.con.cursor()
	cur.execute("DELETE FROM playlist WHERE name <> 'default'")
	cur.execute("DELETE FROM playlistFiles")
	cur.execute("DELETE FROM playlistFilesExtInfo")
	self.con.commit()
      except:
	self.close()
        
  def makeNewPlaylist(self, files, uri, valid_start, valid_end, source):
      # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + str(files) + " " + str(uri) + " " + str(valid_start) + " " + str(valid_end) + " " + source
      self.connect()
      cur = self.con.cursor()
      unique = []
      for f in files:
        if f not in unique:
          unique.append(f)
      try:

        for i in range (0, len(unique)):
          queryString = "INSERT INTO playlistFiles " + "VALUES(null, '1','" + unique[i] + "','" + str(i) +  "')"
          #Logger.debug("Database", queryString)
          cur.execute(queryString)

        for i in range (0, len(files)):
          #get index of filename in unique
          idx = unique.index(files[i])
          queryString = "INSERT INTO playlistFilesExtInfo " + "VALUES(null, '" + str(idx + 1) + "','" + str(valid_start[i]) + "','" +  str(valid_end[i]) + "','" + source + "', '" + uri[i] + "' )"
          #Logger.debug("Database", queryString)
          cur.execute(queryString)
        
        self.con.commit()
      except:
        self.close()


  def makeNewNamedPlaylist(self, name, files, uri, starttime, endtime, source):
      # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + name + " " + str(files) + " " + str(uri) + " " + starttime + " " + endtime + " " + source 
      self.connect()
      try:
	cur = self.con.cursor()
	queryString = "INSERT INTO playlist VALUES(null, '" + name + "','" +\
		      starttime+ "','" + endtime + "','true', 'true', 'true', 'true', 'true', 'true', 'true', 0)"
	#Logger.debug("Database", queryString)
	cur.execute(queryString)
	self.con.commit()
      
	# need to get id of playlist
	queryString = "SELECT id FROM playlist WHERE name = '" + name +"'"
	queryResult = self.con.execute(queryString).fetchall()[0]
	playlist_id = queryResult[0]

	for i in range (0, len(files)):
	  queryString = "INSERT INTO playlistFiles " + "VALUES(null,'" + str(playlist_id)+"','" + files[i] + "','" + str(i) +  "')"
	  #Logger.debug("Database", queryString)
	  cur.execute(queryString)
	  queryString = "INSERT INTO playlistFilesExtInfo " + "VALUES(null, '" + str(i+1) + "','946684800','2147483647','" + source + "','"+ uri[i] + "')"
	  #Logger.debug("Database", queryString)
	  cur.execute(queryString)
        
	self.con.commit()
      except:
	self.close()

  def makeInstantPlaylist(self, fname, uri):
      # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + fname + " " + uri 
      self.connect()
      try:
	cur = self.con.cursor()
	queryString = "INSERT INTO playlistFiles " + "VALUES(null, '1','" + fname + "','0')"
	#Logger.debug("Database", queryString)
	cur.execute(queryString)
	queryString = "INSERT INTO playlistFilesExtInfo " + "VALUES(null, '0' ,'946684800','2147483647','Cornelius', '" + uri + "')"
	#Logger.debug("Database", queryString)
	cur.execute(queryString)
	self.con.commit()
      except:
        self.close()
    

  def deletePlaylistRecord(self, playlistId, index,array):
      # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + str(playlistId) + " " + str(index) + " " + array
      queryResult = None
      self.connect()
      cur = self.con.cursor()
      try:
        corruptfilename = array[int(index)]
        arraySize = len(array)
        #print "corrupt file name " + corruptfilename
        #Logger.debug("Database", "Database:: Trying to delete " + index)
        queryString = "DELETE FROM playlistFiles WHERE playlist_id = '" + playlistId + "' AND play_order = '" + index + "'"
        #Logger.debug("Database", queryString)
        queryResult = cur.execute("DELETE FROM playlistFiles WHERE playlist_id = '" + playlistId + "' AND play_order = '" + index + "'")
        self.con.commit()
        if ((arraySize > 1) and (index != (arraySize-1))):
          self.reOrderPlayList(arraySize,playlistId,array,corruptfilename)
      except:
        queryResult = None
        self.close()
      finally:
          #self.close()
          if (queryResult == None):
             print "Error deleting record"
          else:
             print "Deleted success"
      return queryResult

  def reOrderPlayList(self,arraySize,playlistId,array,corruptfile):
      # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + str(arraySize) + " " + str(playlistId) + " " + array + " " +corruptfile 
      #print "reOrderPlayList " + str(arraySize)
      self.connect()
      try:
	curr = self.con.cursor()
	limit = int(arraySize)
	#print "limit is" + str(limit)
	indexvalue = 0
	for playOrder in range(0,limit):
          #print "indexvalue value: " + str(indexvalue)
          #print "playorder value: " + str(playOrder) + "corrupt file name: " + corruptfile
          print "playorder Name: " + array[playOrder]
          if corruptfile != array[playOrder]:
              try:
                 query = "UPDATE playlistFiles SET play_order='" + str(indexvalue) + "' WHERE playlist_id='" + playlistId + "' AND filename = '" + array[playOrder] + "'"
                 print(query)
                 curr.execute("UPDATE playlistFiles SET play_order='" + str(indexvalue) + "' WHERE playlist_id='" + playlistId + "' AND filename = '" + array[playOrder] + "'")
                 indexvalue = indexvalue+1
              except:
                 #Logger.debug("Database",  "Error Updating database")
                 pass
	self.con.commit()
      except:
         self.close()

  def insertSystemMessage(self,  service_name, mtype, msg):
      # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + service_name + " " + mtype + " " + msg 
      self.connect()
      try:
	cur = self.con.cursor()
	date =  time.strftime("%d-%m-%y %H:%M:%S", time.localtime(time.time()))
	queryString = "INSERT INTO systemMessages (name, type, date, msg) \
		      VALUES('" + service_name + "', '" + \
		      mtype + "','" + date + "','" + msg + "')"
	#Logger.debug("Database", queryString)
	cur.execute(queryString)
	self.con.commit()
      except:
	self.close()

  def clearExtFileInfo(self):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " 
    self.connect()
    try:
      self.con.execute("DELETE FROM playlistFilesExtInfo")
      self.con.commit()
    except:
      self.close()

  def clearFilesDownloaded(self):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " 
    self.connect()
    try:
      self.con.execute("DELETE FROM playlistDownload")
      self.con.commit()
    except:
      self.close()
 
  def setFileDownloaded(self, url):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + url
    self.connect()
    try:
      self.con.execute("INSERT INTO playlistDownload (uri) VALUES('" + url + "')")
      self.con.commit()
    except:  
      self.close()
    
  def checkFileExists(self, url):
    # print "[defDatabase] " + sys._getframe().f_code.co_name + " " + self.fileName + " " + url
    retval = False
    self.connect()
    try:
      
      # first check if the file is there at all

      chunks = urlparse.urlsplit(url)
      filePath = chunks[2]
      fname = filePath.split('/')[-1]
      #print video_path + fname, os.path.isfile(video_path+fname.replace("%20","_"))
      if os.path.isfile(video_path +fname.replace("%20","_")):
	
	# its, there so if same url
	try:
	  sql = "SELECT uri FROM playlistFilesExtInfo t2 inner join playlistFiles as t1 on t2.playlistFile_id=t1.id and t1.filename = '"+ fname[fname.rfind('/') +1 :].replace("%20","_") + "'"
	  rows = self.con.execute(sql).fetchall()
	  print rows
	  print 'url', url
	  print (url == rows[0][0])
	  uri = rows[0][0]
	  if uri == url:
	    retval = True
	except:
	  pass
    
      # if not in last playlist, check if we are in middle of download and power was lost
      if (retval == False):
        sql = "SELECT uri FROM playlistDownload where uri='" + url + "'"
        rows = self.con.execute(sql).fetchall()
        if rows != []:
          retval = True
    except:
      self.close()
    return retval  

  
