#!/usr/bin/python

from gi.repository import Gtk
from gi.repository import Gdk
from gi.repository import GObject
from Button import Button
from logger import Logger

#########################################
class Overlay(Gtk.Fixed):
  
  BUTTON_COUNTER = 0  
  
  ###########################################
  def __init__(self):
    Gtk.Fixed.__init__(self)
    
  ###########################################
  def createCornerButtons(self, windowWidth, windowHeight):
    # CREATE 4 CORNERS BUTTONS
    
    self.TopLeft = Button(Button.TopLeft)
    self.TopLeft.connect("clicked", self.onButtonClickedLT)

    self.TopRight = Button(Button.TopRight)
    self.TopRight.connect("clicked", self.onButtonClickedRT)
    
    self.BottomLeft = Button(Button.BottomLeft)
    self.BottomLeft.connect("clicked", self.onButtonClickedLB)
    
    self.BottomRight = Button(Button.BottomRight)
    self.BottomRight.connect("clicked", self.onButtonClickedRB)

    self.put(self.TopLeft, 0 , 0)
    self.put(self.TopRight, windowWidth - 100, 0)
    self.put(self.BottomLeft, 0, windowHeight - 100)
    self.put(self.BottomRight, windowWidth - 100, windowHeight - 100)



  ##########################################
  def onButtonClickedRT(self, widget):
    print 'RT'
    self.BUTTON_COUNTER = 1
  
  
  ##########################################
  def onButtonClickedLT(self, widget):
    print 'LT'
    if self.BUTTON_COUNTER == 1 or self.BUTTON_COUNTER == 2:
      self.BUTTON_COUNTER = 2 
    else:
      self.BUTTON_COUNTER = 0
    
    
  ##########################################
  def onButtonClickedLB(self, widget):
    print 'LB'
    if self.BUTTON_COUNTER == 2 or self.BUTTON_COUNTER == 3:
      self.BUTTON_COUNTER = 3
  
  ##########################################
  def onButtonClickedRB(self, widget):    
    print 'RB'
    if self.BUTTON_COUNTER == 3:
      Logger.debug("VideoPlayer",  "Enable Service UI")
      self.emitSignal("signal-show-service-ui")      
      self.BUTTON_COUNTER = 0

  
  ##########################################
  def emitSignal(self, *args):
    GObject.idle_add(GObject.GObject.emit, self,*args)
