
#!/usr/bin/python

# ******************************************************************************
# *                                                                            
# *   Copyright 2014 Cornelius, Inc. All rights reserved.                      
# *                                                                            
# *   This file is confidential and a trade secret of Cornelius, Inc.         
# *   The receipt of or possession of this file does not convey any rights     
# *   to reproduce or disclose its contents or to manufacture, use, or sell    
# *   anything it may describe, in whole, or in part, without the specific     
# *   written consent of Cornelius, Inc.                                       
# *                                                                            
# ******************************************************************************
# ------------------------------------------------------------------------------
#
#    DEVELOPED BY : Michal Augustyniak
#                   Modified. M. Singer
#
# ------------------------------------------------------------------------------


from gi.repository import GObject
from logger import Logger
import time
import os
import sys
import urllib2
import os.path
from urllib2 import urlparse
import traceback
import threading
from Queue import Queue
import urllib
import socket

GObject.threads_init()
socket.setdefaulttimeout(30)

class Downloader(GObject.GObject, threading.Thread):
    def __init__(self, queue):
        GObject.GObject.__init__(self)
        threading.Thread.__init__(self)
        self.thread = threading.Thread
        self.queue = queue
        self.bad_files = []
        self.downloading = False
        self.SHOULD_RUN = True

    def isAlive(self):
        print "Downloader alive"
        return "yes"

    def terminate(self):
        self.SHOULD_RUN = False

    def resetFiles(self):
        self.bad_files = []

    def emitSignal(self, *args):
        GObject.idle_add(GObject.GObject.emit, self,*args)

    def run(self):
        Logger.info("Downloader", "started")
        while self.SHOULD_RUN:
            # hack so we can terminate thread on corco stop
            if (self.queue.empty()) :
                time.sleep(1)
                continue
            download_url, save_as = self.queue.get(True)
            # sentinal
            if  not download_url:
                Logger.info("Downloader", "Download queue complete")
                self.downloading = False
                self.emitSignal("signal_download_complete")    
                continue
            self.downloading = True
            xml =  ".xml" in download_url
            if  xml == False:
               self.emitSignal("signal_download_started")    
            print download_url, ".xml" in download_url
            for retries in range(0,3):
                try:
                    Logger.info("Downloader", 'downloading %s' % (save_as))
                    urllib.urlretrieve(download_url, filename=save_as)
                    # check that file is not corrupt
                    if ".mp4" in save_as:
                        result = os.popen('nice ffmpeg -loglevel 16 -i "%s" -f null - 2>&1' % save_as).read()
                        if len(result):
                            Logger.info("Downloader", "corruption error downloading %s" % (download_url))
                        else:
                            self.emitSignal("signal_download_file_complete", download_url)    
                            break
                    else:
                          self.emitSignal("signal_download_file_complete", download_url)    
                          break
  
                except Exception, e:
                    traceback.print_exc(file=sys.stdout)
                # on 3rd try, mark file failed
                if (retries == 2):
                    if save_as not in self.bad_files:
                        self.bad_files.append(save_as)


