#!/usr/bin/python

# ******************************************************************************
# *                                                                            
# *   Copyright 2014 Cornelius, Inc. All rights reserved.                      
# *                                                                            
# *   This file is confidential and a trade secret of Cornelius, Inc.          
# *   The receipt of or possession of this file does not convey any rights     
# *   to reproduce or disclose its contents or to manufacture, use, or sell    
# *   anything it may describe, in whole, or in part, without the specific     
# *   written consent of Cornelius, Inc.                                       
# *                                                                            
# ******************************************************************************
# ------------------------------------------------------------------------------
#
#    DEVELOPED BY : Michal Augustyniak
#
# ------------------------------------------------------------------------------

import logging
from time import gmtime, strftime
import sys
import DatabaseHelper

refreshDatabase = DatabaseHelper.DatabaseConnection("/opt/Refresh/Database/refresh_database_enc.db")
               
class Logger():

  @staticmethod                        
  def currentTime():
    return strftime("%Y-%m-%d %H:%M:%S", gmtime())

  @staticmethod                        
  def log(msg):    
    print msg
    sys.stdout.flush()

  @staticmethod                        
  def info(label, msg):    
    print "%s Info : [%s] -> %s" % (Logger.currentTime(), label, msg)      
    sys.stdout.flush()
    
  @staticmethod                        
  def debug(label, msg):
    print "%s Debug: [%s] -> %s" % (Logger.currentTime(), label, msg)      
    sys.stdout.flush()
    
  @staticmethod                        
  def warning(label, msg):
    print "%s Warn : [%s] -> %s" % (Logger.currentTime(), label, msg)    
    sys.stdout.flush()
    refreshDatabase.insertSystemMessage("VideoPlayer", "Warning", msg)      
  
  @staticmethod                        
  def critical(label, msg):
    print "%s Crit : [%s] -> %s" % (Logger.currentTime(), label, msg)    
    sys.stdout.flush()
    refreshDatabase.insertSystemMessage("VideoPlayer", "Critical", msg)      
    
  @staticmethod                        
  def error(label, msg):
    print "%s Error: [%s] -> %s" % (Logger.currentTime(), label, msg)    
    #log.critical(msg)
    sys.stdout.flush()

  @staticmethod                        
  def data(label, msg):    
    print "%s Data : [%s]  * %s" % (Logger.currentTime(), label, msg)    
    sys.stdout.flush()
